<?

	$destFileName = 'IPS_PhpEclipse_Template.xml';

	// load all IPS definitions
	$fList = IPS_GetFunctionList(0);
	asort($fList);
	$typeStr = Array("boolean", "integer", "float", "string", "variant", "array");

	// the writer
	$writer = new XMLWriter();
	$writer->openMemory();
	$writer->startDocument('1.0', 'UTF-8', 'no');

	$writer->startElement('templates');

	// iterate through functions
	foreach ($fList as $fEntry)
	{
		// the function
		$fName = $fEntry["FunctionName"];
		// the parameter(s)
		$fParams = $fEntry["Parameters"];
		// the result
		$fResult = $fEntry["Result"];

		// assemble parameter and desc string
		$params = "";
		$descParam = "";
		foreach ($fParams as $fParam)
		{
			if ($descParam != "") $descParam .= ", ";
			$descParam .= $fParam["Description"].": ".$typeStr[$fParam["Type_"]];

			if ($params != "") $params .= ", ";
			$params .= '$$${' . $fParam["Description"] . "}";
		}
		$descResult = $typeStr[$fResult["Type_"]];

		// the template...
		$writer->startElement('template');
		$writer->writeAttribute('autoinsert', 'true');
		$writer->writeAttribute('context', 'php');
		$writer->writeAttribute('deleted', 'false');
		$writer->writeAttribute('description', $fName.'('.$descParam.'): '.$descResult);
		$writer->writeAttribute('enabled', 'true');
		$writer->writeAttribute('id', 'ips.php.'.$fName);
		$writer->writeAttribute('name', $fName);
		$writer->text($fName.'('.$params.');${cursor}');
		$writer->endElement();  // template

	}
	$writer->endElement();  // templates
	$writer->endDocument();

	// and save
	$fHandle = fopen (IPS_GetKernelDir().$destFileName, "w");
	fwrite($fHandle, $writer->outputMemory(true));
	fclose($fHandle);

?>